' TESTER AKUMULATORW Z ADOWARK - by Adam Sobczyk SQ5RWQ (06'14-04'15)
$regfile = "m8def.dat"
$crystal = 8000000
$hwstack = 40
$swstack = 16
$framesize = 32

'STEROWANIE - WEJCIA ----------------------------------------------------------
Config Portd.0 = Input : Portd.0 = 1 : Minus Alias Pind.0   ' [<-] - do tyu / zmniejszenie prdu ; dodany pull-up
Config Portd.1 = Input : Portd.1 = 1 : Ok Alias Pind.1      ' [OK] - potwierdzenie wyboru opcji ; dodany pull-up
Config Portd.2 = Input : Portd.2 = 1 : Plus Alias Pind.2    ' [+>] - do przodu / zwikszenie prdu ; dodany pull-up
Config Portd.3 = Input : Portd.3 = 1 : Lt Alias Pind.3      ' [LCD] LCD Backlight on/off ; dodany pull-up

'STEROWANIE - WYJCIA ----------------------------------------------------------
Config Portb.3 = Output : Portb.3 = 0 : Acccon Alias Portb.3       ' [Accu Connect] - doczanie akumulatora
Config Portc.4 = Output : Portc.4 = 0 : Buzon Alias Portc.4 ' [buzer ON] - zaczenie buzera
Config Portc.5 = Output : Portc.5 = 0 : Ledwarn Alias Portc.5       ' [LED Warning] - Orange LED Warning
Config Portd.4 = Output : Portd.4 = 1 : Lcdlite Alias Portd.4       ' [LCD LT ON] - zaczenie podwietlenia LCD

'Config LCD --------------------------------------------------------------------
Config Lcdpin = Pin , Rs = Portb.6 , E = Portb.7 , Db4 = Portd.5 , Db5 = Portd.6 , Db6 = Portd.7 , Db7 = Portb.0
Config Lcd = 16 * 2

Deflcdchar 0 , 32 , 14 , 17 , 17 , 17 , 10 , 27 , 32        ' Ohm
Deflcdchar 1 , 8 , 20 , 28 , 20 , 4 , 6 , 5 , 5             ' Ah
Deflcdchar 3 , 32 , 4 , 4 , 14 , 14 , 31 , 31 , 32          ' strzaka w gr
Deflcdchar 4 , 32 , 31 , 31 , 14 , 14 , 4 , 4 , 32          ' strzaka w d
Deflcdchar 5 , 32 , 10 , 21 , 10 , 21 , 10 , 21 , 32        ' szachownica parametryzacji

Cls : Cursor Off
Upperline : Lcd "AccuTest  v.2.00"
Lowerline : Lcd "AVT3126 (SQ5RWQ)"
Wait 3
Cls

'Config ADC --------------------------------------------------------------------
Config Adc = Single , Prescaler = 64 , Reference = Internal ' Vref=2.56V
Start Adc

'Config DAC/PWM ----------------------------------------------------------------
Config Portb.1 = Output : Portb.1 = 0                       ' wstepnie
Config Portb.2 = Output : Portb.2 = 0                       ' wstepnie
Config Timer1 = Pwm , Pwm = 10 , Compare A Pwm = Clear_up , Compare B Pwm = Clear_up , Prescale = 1
Pwm1a = 0                                                   ' ustawienie wstpne - bezpieczne
Pwm1b = 0                                                   ' ustawienie wstpne - bezpieczne
Enable Timer1

'STAA - liczba pomiarw ADC, wykonywanych "pod rzd" dla zwikszenia dokadnoci (30 daje prb statystyczn i opnienie <0.5% podstawy czasu pomiaru, czyli 1 sek.)
Const Nmeasure = 30

'Zmienne -----------------------------------------------------------------------
Dim Measure As Word                                         ' dowolny pomiar z ADC
Dim N As Byte , M As Word                                   ' uniwersalne iteratory
Dim Adcchan As Byte                                         ' numer kanau ADC, ktry bdzie czytany

Dim Vb As Single                                            ' sterowanie napiciem DAC PWM dla baz rde prdowych
Dim Vbw As Word                                             ' j.w., ale wersja Word zmiennej
Dim Ia As Single                                            ' pomiar prdu akumulatora I
Dim Uz As Single                                            ' pomiar napicia zasilania U
Uz = 12.0                                                   ' ustawienie wstpne - typowo (na potrzeby kalibracji)
Dim Ua As Single                                            ' pomiar napicia akumulatora U
Ua = 6.0                                                    ' ustawienie wstpne - na potrzeby kalibracji po podczenia zewntrznego rda napicia ok. 6V

Dim A3 As Single , A2 As Single , A1 As Single              ' stae do skalowania dzielnikw napicia - ewentualna kalibracja nadpisze je
Readeeprom A3 , 10 : Readeeprom A2 , 14 : Readeeprom A1 , 18

Dim Umin(5) As Single , Umax(5) As Single                   ' progi napi akceptacji, adowania i rozadowania
'1. NiMH
Umin(1) = 1.0 : Umax(1) = 1.4                               ' Unom=1.2V
'2. Li-Ion
Umin(2) = 3.0 : Umax(2) = 4.2                               ' Unom=3.6..3.7V
'3. Lead-Acid
Umin(3) = 1.8 : Umax(3) = 2.4                               ' Unom=2.1V
'4. Zinc-Carbon
Umin(4) = 1.0 : Umax(4) = 1.7                               ' Unom=1.5V
'5. Zinc-Mangan (alkaline)
Umin(5) = 1.0 : Umax(5) = 1.7                               ' Unom=1.5V

'Orientacyjne porwnanie pojemnoci popularnych ogniw typu "AA" (wg http://pl.wikipedia.org/wiki/Bateria_AA):
'- 4001000 mAh baterie wglowo-cynkowe
'- do 2300 mAh baterie alkaliczne
'- 17002900 mAh akumulatory NiMH
'- okoo 3000 mAh baterie Lithium oparte na Li-FeS2

Dim Atype As Byte                                           ' typ akumulatora
Atype = 1                                                   ' Ni-MH - default
Dim Ncmax As Byte                                           ' max. l-ba ogniw dla danego typu akumulatora
Dim Nc As Byte                                              ' liczba ogniw w akumulatorze (teoret. max. = 8)

Dim Ftype As Byte                                           ' funkcja programu - do wyboru
Ftype = 1                                                   'ROZadowywanie - default

Dim Ir As Word                                              ' [mA] zadany prd roboczy (adowania lub rozadowania)
Ir = 300

Dim Ud As Single , Ug As Single                             ' dopuszczalne napicia graniczne wybranego rda energii

Dim Qa As Single                                            ' adunek zliczony [mAsek] - zaadowany do akumulatora lub wyadowany z niego
Dim Qa1 As Single                                           ' adunek do zaprezentowania na LCD [Ah] - zaadowany do akumulatora lub wyadowany z niego


' Zzmienne do pomiaru oporu wewntrznego Rwe oraz kalibracji oporu szeregowego przyczenia Rser
Dim Ualo As Single , Uahi As Single
Dim Ialo As Single , Iahi As Single
Dim Rwe As Single , Rser As Single
Rser = 0                                                    ' na wypadek, gdyby kto chcia mierzy Rwe bez wstpnej kalibracji

Dim Strtopokaz As String * 5                                ' zmienna pomocnicza do skracania wyswietlanych parametrow

Dim Islong As Bit                                           ' flaga formatu wywietlania Ua i Rwe: 1 - dugi, 0 - krtki
Dim Isakuok As Bit                                          ' flaga prawidowoci parametrw (typu) podczonego akumulatora
Isakuok = 0



'------------------- BLOK USTAWIANIA PARAMETRW PODSTAWOWYCH -------------------
Cursor On , Blink

' Wybr typu badanego rda energii
Do
  If Minus = 0 And Atype > 1 Then
    Decr Atype
  Elseif Plus = 0 And Atype < 5 Then
    Incr Atype
  End If
  Locate 1 , 1
  Select Case Atype
    Case 1
         Ncmax = 4
         Lcd "NiMH"                                         ' akumulator Ni-MH
    Case 2
         Ncmax = 2
         Lcd "LiIn"                                         ' akumulator Li-Ion lub Li-Po
    Case 3
         Ncmax = 3
         Lcd "LdAc"                                         ' akumulator kwasowo-oowiowy
    Case 4
         Ncmax = 4
         Lcd "Zn-C"                                         ' ogniwo wglowe
    Case 5
         Ncmax = 4
         Lcd "ZnMn"                                         ' ogniwo alkaliczne
  End Select
  Waitms 200
Loop Until Ok = 0
Waitms 300

' Wybr iloci ogniw (cel) w szeregu
Nc = 1
Lcd "*" ; Nc
Do
  If Minus = 0 And Nc > 1 Then
    Decr Nc
  Elseif Plus = 0 And Nc < Ncmax Then
    Incr Nc
  End If
  Locate 1 , 6 : Lcd Nc
  Waitms 200
Loop Until Ok = 0
Waitms 300

' Ustawienie prdu roboczego
Do
  If Minus = 0 And Ir > 100 Then
    Ir = Ir - 10
  Elseif Plus = 0 And Ir < 500 Then
    Ir = Ir + 10
  End If
  Gosub Pokazir
  Waitms 200
Loop Until Ok = 0
Waitms 300

' Wyznaczenie dopuszczalnych napi granicznych rda energii
Ud = Nc * Umin(atype)
Ug = Nc * Umax(atype)



'--------------------------- GWNA PTLA PROGRAMU -----------------------------
Cursor Off , Noblink
Do
  Do
    If Minus = 0 And Ftype > 1 Then
      Decr Ftype
    Elseif Plus = 0 And Ftype < 5 Then
      Incr Ftype
    End If

    Locate 1 , 13
    Select Case Ftype
      Case 1
           Lcd "ROZ" ; Chr(4)
      Case 2
           Lcd "LAD" ; Chr(3)
      Case 3
           Lcd "OPO" ; Chr(4)
      Case 4                                                ' kalibracja koszyczka
           Lcd "KAL" ; Chr(3)
      Case 5
           Lcd "PAR" ; Chr(5)                               ' parametryzacja dzielnikow pomiarowych
    End Select
    Waitms 200
  Loop Until Ok = 0

  Select Case Ftype
    Case 1
         Gosub Roz
    Case 2
         If Atype <= 3 Then                                 ' Warunek I-y - nie ladujemy "ogniw pierwotnych" czyli tzw. zwykych nieadowalnych "bateryjek" jednorazowego uytku
            If Atype <> 2 Or Nc = 1 Then                    ' Warunek II-i - nie jest to ogniwo Li-Ion (ew. Li-Po) lub testujemy tylko pojedyncze ogniwo (w szeregu)
              Gosub Lad
            End If
         End If
    Case 3
         Gosub Opo
    Case 4
         Gosub Kal
    Case 5
         Gosub Par
  End Select
Loop


'------------------------ ROZADOWYWANIE - podprogram ------------------------
Roz:
  ' Wstpny test odpowiednioci napicia akumulatora - czy w dozwolonych granicach?
  Gosub Pretestua
  If Isakuok = 0 Then
    Return
  End If

  Lowerline : Lcd Spc(16)
  Qa = 0                                                    ' reset zmierzonego adunku

  ' wstpne wyznaczenie wartoci sygnau sterujcego DAC PWM dla bazy Q7 [V] przy danym Ir [mA]
  'Vb = Ir * 0.47 : Vb = Vb / 1000 : Vb = Vb + 1.4 : Vb = Vb * 2 : Vb = Vb / 5 : Vb = Vb * 1023 ' wstpne rednie Ube2(Q7,Q8) przyjto na ok. 1.4V
  Vb = 0.192324 * Ir : Vb = Vb + 572.88                     ' to samo, co powyej, ale krcej i szybciej
  Vbw = Round(vb)

  Set Acccon                                                ' podczenie akumulatora
  Do
    Set Ledwarn

    ' Wielocykl rozadowania
    For M = 1 To 18
      Pwm1a = Vbw
      Wait 1
      Gosub Testidschg
      Gosub Pokazia                                         ' pokazuje faktyczny zmierzony prd roboczy w danym kroku
      Qa = Qa + Ia                                          ' na koniec nastpi przeliczenie na [Ah] przez podzia / 3600000 (sek/h)
      Iahi = Ia
      Gosub Korekta                                         ' ta procedura modyfikuje zmienn Ia !!!
      Gosub Lcdproc
    Next M
    Gosub Testua                                            ' pomiar jeszcze pod obcieniem
    Ualo = Ua

    ' Przerwa w rozadowywaniu i test napicia i prdu akumulatora
    Pwm1a = 0 : Reset Ledwarn
    For M = 1 To 2
      Wait 1
      Gosub Lcdproc
    Next M

    ' Pomiar bez obcienia
    Gosub Testua : Uahi = Ua
    Gosub Testidschg : Ialo = Ia

    Islong = 0                                              ' krtki format
    Gosub Pokazstan
    Gosub Lcdproc
  Loop Until Ua <= Ud                                       'cakowite rozadowanie

  Reset Acccon                                              'odczenie akumulatora
  Gosub Alert
  Set Lcdlite
  Gosub Pokazir
Return


'------------------------ ADOWANIE - podprogram ------------------------
Lad:
  ' Wstpny test odpowiednioci napicia akumulatora - czy w dozwolonych granicach?
  Gosub Pretestua
  If Isakuok = 0 Then
    Return
  End If

  Lowerline : Lcd Spc(16)
  Qa = 0                                                    ' reset zmierzonego adunku

  ' wstpne wyznaczenie wartoci sygnau sterujcego DAC PWM dla bazy Q4 [V] przy danym Ir [mA]
  'Vb = Ir * 3.9 : Vb = Vb / 1000 : Vb = Vb + 1.4 : Vb = Vb / 3300 : Vb = Vb * 3900 : Vb = Vb + 0.7 : Vb = Vb / 5 : Vb = Vb * 1023 ' wstpne rednie Ube(Q4) oraz Ube2(Q5,Q6) przyjto na ok. 0.7 i 1.4V
  Vb = 0.94302 * Ir : Vb = Vb + 481.74                      ' to samo, co powyej, ale krcej i szybciej
  Vbw = Round(vb)

  Set Acccon                                                ' podczenie akumulatora
  Do
    Set Ledwarn

    ' Wielocykl adowania
    For M = 1 To 18
      Pwm1b = Vbw
      Wait 1
      Gosub Testuz : Gosub Testichg
      Gosub Pokazia                                         ' pokazuje faktyczny zmierzony prd roboczy w danym kroku
      Qa = Qa + Ia                                          ' na koniec nastpi przeliczenie na [Ah] przez podzia / 3600000 (sek/h)
      Iahi = Ia
      Gosub Korekta                                         ' ta procedura modyfikuje zmienn Ia !!!
      Gosub Lcdproc
    Next M
    Gosub Testua                                            ' pomiar jeszcze pod obcieniem
    Uahi = Ua

    Gosub Testua : Uahi = Ua
    Gosub Testichg : Iahi = Ia

    ' Przerwa w adowaniu i test napicia akumulatora
    Pwm1b = 0 : Reset Ledwarn
    For M = 1 To 2
      Wait 1
      Gosub Lcdproc
    Next M

    ' Pomiar bez obcienia
    Gosub Testua : Ualo = Ua
    Gosub Testuz : Gosub Testichg : Ialo = Ia

    Islong = 0                                              ' krtki format
    Gosub Pokazstan
    Gosub Lcdproc

  Loop Until Ua => Ug                                       'cakowite naadowanie

  Reset Acccon                                              'odczenie akumulatora
  Gosub Alert
  Set Lcdlite
  Gosub Pokazir
Return


'------------------------ OPORNO WEWNTRZNA - podprogram ------------------------
Opo:
  ' Wstpny test odpowiednioci napicia akumulatora - czy w dozwolonych granicach?
  Gosub Pretestua
  If Isakuok = 0 Then
    Return
  End If

  Lowerline : Lcd Spc(16)
  Ualo = 0 : Uahi = 0
  Ialo = 0 : Iahi = 0
  Islong = 1                                                ' dugi format wywietlania

    ' wstpne wyznaczenie wartoci sygnau sterujcego DAC PWM dla bazy Q7 [V] przy danym Ir [mA]
  'Vb = Ir * 0.47 : Vb = Vb / 1000 : Vb = Vb + 1.4 : Vb = Vb * 2 : Vb = Vb / 5 : Vb = Vb * 1023 ' wstpne rednie Ube2(Q7,Q8) przyjto na ok. 1.4V
  Vb = 0.192324 * Ir : Vb = Vb + 572.88                     ' to samo, co powyej, ale krcej i szybciej
  Vbw = Round(vb)

  Set Ledwarn
  Set Acccon                                                ' podczenie akumulatora

  'Doprecyzowanie prdu rozadowywania w ustalonym punkcie pracy testu
  For M = 1 To 1024                                         ' skoczona liczba iteracji, teoretycznie pozwalajca osign zadany prd Ir, zawsze gdy jest to tylko moliwe
    Pwm1a = Vbw                                             ' nastawa lub korekta prdu rozadowania
    Gosub Testidschg
    Gosub Pokazia                                           ' pokazuje faktyczny zmierzony prd roboczy w danym kroku
    Gosub Korekta                                           ' wyliczenie korekty prdu rozadowania -> Ia chwilowo jest bdem nastawienia prdu: Ia = Ir - Ia po wykonaniu procedury 'Korekta'
    If -5 < Ia And Ia < 5 Then                              ' [mA] granice dokadnoci, wyznaczone przez 5% z najmniejszej dopuszczalnej nastawy prdu
      Exit For
    End If
  Next M

  ' Wielocykl testu Rwe
  For M = 1 To 50                                           ' zapewnienie prbki pomiarowej, statystycznie uytecznej
    Pwm1a = 0                                               ' zamykamy cakowicie rdo prdowe
    Waitms 250                                              ' 5 * przyblione stae czasowe obwodow filtrujacych (40ms): wymuszenia PWM i pomiarowych ADC (z zapasem +25% na niedokadno elementw)
    Gosub Testua
    Gosub Pokazua
    Gosub Testidschg
    Ialo = Ialo + Ia : Uahi = Uahi + Ua                     ' suma w celu usredniania na koncu, co pozwala zwikszy dokadno pomiarw; Ia - wersja single dla wikszej dokadnoci

    Pwm1a = Vbw                                             ' otwieramy rdo prdowe do spodziewanej wartoci Ir
    Waitms 250                                              ' 5 * przyblione stae czasowe obwodow filtrujacych (40ms): wymuszenia PWM i pomiarowych ADC (z zapasem +25% na niedokadno elementw)
    Gosub Testua
    Gosub Testidschg
    Gosub Pokazia                                           ' pokazuje faktyczny zmierzony prd roboczy w danym kroku
    Iahi = Iahi + Ia : Ualo = Ualo + Ua                     ' suma w celu usredniania na koncu, co pozwala zwikszy dokadno pomiarw; Ia - wersja single dla wikszej dokadnoci
  Next M

  ' Koniec testu Rwe
  Pwm1a = 0
  Reset Acccon                                              'odczenie akumulatora
  Reset Ledwarn
  Gosub Pokazrwe
  Gosub Pokazir
Return



'------------------------ KALIBRACJA OPORNOCI KOSZYCZKA I DOPROWADZE - podprogram ------------------------
Kal:
  Lowerline : Lcd Spc(16)
  Ualo = 0 : Uahi = 0
  Ialo = 0 : Iahi = 0
  Islong = 1

  ' wstpne wyznaczenie wartoci sygnau sterujcego DAC PWM dla bazy Q4 [V] przy danym Ir [mA]
  'Vb = Ir * 3.9 : Vb = Vb / 1000 : Vb = Vb + 1.4 : Vb = Vb / 3300 : Vb = Vb * 3900 : Vb = Vb + 0.7 : Vb = Vb / 5 : Vb = Vb * 1023 ' wstpne rednie Ube(Q4) oraz Ube2(Q5,Q6) przyjto na ok. 0.7 i 1.4V
  Vb = 0.94302 * Ir : Vb = Vb + 481.74                      ' to samo, co powyej, ale krcej i szybciej
  Vbw = Round(vb)

  Set Ledwarn
  Set Acccon                                                ' podczenie akumulatora
  'Doprecyzowanie prdu adowania w ustalonym punkcie pracy testu
  Do
    Pwm1b = Vbw                                             ' nastawa lub korekta prdu adowania
    Gosub Testichg
    Gosub Pokazia                                           ' pokazuje faktyczny zmierzony prd roboczy w danym kroku
    Gosub Korekta                                           ' wyliczenie korekty prdu adowania -> Ia chwilowo jest bdem nastawienia prdu: Ia = Ir - Ia po wykonaniu procedury 'Korekta'
  Loop Until -10 <= Ia And Ia <= 10                         ' [mA] granice wyznaczone przez 10% z najmniejszej dopuszczalnej nastawy prdu; dokadno zupenie wystarczajca do tego zadania

  ' Wielocykl testu Rser
  For M = 1 To 50                                           ' zapewnienie prbki pomiarowej, statystycznie uytecznej
    Pwm1b = 0                                               ' zamykamy cakowicie rdo prdowe
    Waitms 250                                              ' 5 * przyblione stae czasowe obwodow filtrujacych (40ms): wymuszenia PWM i pomiarowych ADC (z zapasem +25% na niedokadno elementw)
    Gosub Testua
    Gosub Testichg
    Ialo = Ialo + Ia : Ualo = Ualo + Ua                     ' suma w celu usredniania na koncu, co pozwala zwikszy dokadno pomiarw; Ia - wersja single dla wikszej dokadnoci
    Pwm1b = Vbw                                             ' otwieramy rdo prdowe do spodziewanej wartoci Ir
    Waitms 250                                              ' 5 * przyblione stae czasowe obwodow filtrujacych (40ms): wymuszenia PWM i pomiarowych ADC (z zapasem +25% na niedokadno elementw)
    Gosub Testua
    Gosub Pokazua
    Gosub Testichg
    Gosub Pokazia                                           ' pokazuje faktyczny zmierzony prd roboczy w danym kroku
    Iahi = Iahi + Ia : Uahi = Uahi + Ua                     ' suma w celu usredniania na koncu, co pozwala zwikszy dokadno pomiarw; Ia - wersja single dla wikszej dokadnoci
  Next M

  ' Koniec testu kalibracyjnego Rser
  Pwm1b = 0
  Reset Acccon                                              'odczenie akumulatora
  Reset Ledwarn
  Ua = Uahi - Ualo : Ua = 1000 * Ua                         ' dla spjnoci, bo Ia jest wyraone w [mA]
  Ia = Iahi - Ialo : Rser = Ua / Ia

  If Rser < 0 Then                                          ' zmierzono warto tak ma (blisk zeru), e bd pomiarowy spowodowa ujemny wynik
     Rser = 0
  End If
  Locate 2 , 9 : Lcd Fusing(rser , "#.###") ; Chr(0) ; " "
  Gosub Pokazir
Return



'--------------------------- PODPROGRAMY POMOCNICZE ----------------------------
Pomiar:
  Measure = 0
  For N = 1 To Nmeasure                                     ' wielokrotny pomiar daje wiksz dokadno i stabilno wyniku
    Measure = Measure + Getadc(adcchan)
    Waitus 128                                              ' opnienie o ok. 1/2 okresu rde sterujcych PWM - celem eliminacji pochodzcych od nich zakce (dekorelacja czasowa)
  Next N
Return


Testuz:                                                     'Uz - zasilanie [V]
  Adcchan = 3 : Gosub Pomiar
  Uz = A3 * Measure
  Uz = Uz / Nmeasure                                        ' uwzgldnienie wielokrotnych pomiarw dla zwikszenia dokadnoci
Return


Testua:                                                     'Ua - akumulator [V]
  Adcchan = 1 : Gosub Pomiar
  Ua = A1 * Measure
  Ua = Ua / Nmeasure                                        ' uwzgldnienie wielokrotnych pomiarw dla zwikszenia dokadnoci
Return


Testidschg:                                                 'Ia - prd rozadowywania
  Adcchan = 0 : Gosub Pomiar
  'Ia = Measure * 2.56 : Ia = Ia / 1024 : Ia = Ia / 0.47 : Ia = 1000 * Ia
  Ia = 5.319149 * Measure                                   ' [mA]; operacje j.w., ale po przeliczeniu wynikw w/w dziaa arytmetycznych
  Ia = Ia / Nmeasure                                        ' uwzgldnienie wielokrotnych pomiarw dla zwikszenia dokadnoci
Return


Testichg:                                                   'Ia - prd adowania (pomiar rnicowy)
  Adcchan = 2 : Gosub Pomiar
  Ia = A2 * Measure
  Ia = Ia / Nmeasure                                        ' uwzgldnienie wielokrotnych pomiarw dla zwikszenia dokadnoci
  Ia = Uz - Ia
  ' Ia = Ia / 3.9, Ia = 1000 * Ia
  Ia = 256.41 * Ia                                          ' [mA]; operacje j.w., ale po przeliczeniu wynikw w/w dziaa arytmetycznych
Return


Korekta:
  Ia = Ir - Ia                                              ' Uwaga: tymczasowe uycie zmiennej Ia jako miary bdu wartoci prdu !!!
  ' korekta wartoci napicia sterujcego
  If Ia > 0 And Vbw < 1023 Then
    Incr Vbw
  Elseif Ia < 0 And Vbw > 0 Then
    Decr Vbw
  End If
Return


Pokazua:
  Lowerline
  If Islong = 0 Then
    Lcd Fusing(ua , "#.##") ; "V"
  Else
    Lcd Fusing(ua , "#.###") ; "V "
  End If
Return


Pokazrwe:
  Uahi = Uahi - Ualo : Uahi = 1000 * Uahi                   ' dla spjnoci, bo Ia jest wyraone w [mA]
  Iahi = Iahi - Ialo : Rwe = Uahi / Iahi
  Rwe = Rwe - Rser

  If Islong = 0 Then                                        ' format skrcony
     Strtopokaz = Fusing(rwe , "#.##")
     If Rwe < 1 Then                                        ' typowo Rwe < 1
       Strtopokaz = Right(strtopokaz , 3)                   ' tniemy zero z przodu
     Else
       Strtopokaz = Left(strtopokaz , 3)                    ' tniemy setne Ohm jako nieistotne
     End If
     Locate 2 , 7 : Lcd Strtopokaz ; Chr(0) ; " "
   Else                                                     ' format peny
     Locate 2 , 9 : Lcd Fusing(rwe , "#.###") ; Chr(0) ; " "
   End If
Return


Pokazqa:
  Qa1 = Qa / 3600000                                        ' Qa1=sum(dIa * dT) / 3600000 dla Ia [mA], dT=1 sek. i Qa1 prezentowanego w [Ah]
  Strtopokaz = Fusing(qa1 , "#.###")
  If Qa1 < 1 Then                                           ' typowo Qa1 > 1
    Strtopokaz = Right(strtopokaz , 4)                      ' tniemy zero z przodu
  Else
    Strtopokaz = Left(strtopokaz , 4)                       ' tniemy najmniej znaczce cyfry jako nieistotne dla dokadnoci odczytu
  End If
  Locate 2 , 12 : Lcd Strtopokaz ; Chr(1)
Return


Pokazir:
  Locate 1 , 8
  Lcd "." ; Ir
  Shiftcursor Left
  Lcd "A "
Return


Pokazia:
  Strtopokaz = Fusing(ia , "#.#")                           ' zamiana zmiennej na tekst
  Locate 1 , 8
  Lcd "." ; Left(strtopokaz , 2) ; "A "
Return


Pokazstan:
  Gosub Pokazua
  Gosub Pokazrwe
  Gosub Pokazqa
Return


' Wstpny test napicia rda energii (czy Ua mieci si w wyznaczonych granicach)
Pretestua:
   Set Acccon
   Set Ledwarn
   Wait 2                                                   'podczenie akumulatora; T >> RC dla ADC1
   Gosub Testua
   Islong = 1                                               ' format precyzyjny
   Gosub Pokazua
   Reset Acccon
   Locate 2 , 8
   If Ua > Ug Or Ua < Ud Then
     Lcd "    NOK  "
     Gosub Alert
     Isakuok = 0
   Else
     Lcd "    OK   "
     Isakuok = 1
   End If
   Wait 2
   Reset Ledwarn                                            'odczenie akumulatora
Return


Lcdproc:
  If Lt = 0 Then                                            ' wcisniety przycisk podwietlenia/zgaszenia LCD
     Toggle Lcdlite
  End If
Return


Alert:
  For M = 1 To 3
    For N = 1 To 3
      Set Ledwarn : Set Buzon
      Waitms 50
      Reset Ledwarn : Reset Buzon
      Waitms 50
    Next N
    Waitms 100
  Next M
Return


' Parametryzacja ------------------------------------------------------
Par:
    Cls : Lcd "Parametryzacja"
    Wait 1

    'Stae A3, A2 - dla Uz i grnego rda
    Do
      Lowerline : Lcd "Uz=?" ; Fusing(uz , "#.##") ; "V? "
      If Minus = 0 Then
         Uz = Uz - 0.01
      Elseif Plus = 0 Then
         Uz = Uz + 0.01
      End If
      Waitms 200
    Loop Until Ok = 0
    Adcchan = 3 : Gosub Pomiar : A3 = Uz * Nmeasure : A3 = A3 / Measure : Writeeeprom A3 , 10
    Adcchan = 2 : Gosub Pomiar : A2 = Uz * Nmeasure : A2 = A2 / Measure : Writeeeprom A2 , 14

    'Staa A1 - dla akumulatora
    Set Acccon : Set Ledwarn
    Do
      Lowerline : Lcd "Ua=?" ; Fusing(ua , "#.##") ; "V? "
      If Minus = 0 Then
         Ua = Ua - 0.01
      Elseif Plus = 0 Then
         Ua = Ua + 0.01
      End If
      Waitms 200
    Loop Until Ok = 0
    Wait 2                                                  ' Stabilizacja napicia wejciowego ADC (b. precyzyjnie - T>>RC filtru)
    Adcchan = 1 : Gosub Pomiar : A1 = Ua * Nmeasure : A1 = A1 / Measure : Writeeeprom A1 , 18
    Reset Acccon : Reset Ledwarn                            'odczenie akumulatora
   Lowerline : Lcd "zakonczona.   "
   Wait 5
   Cls
Return